var MAX_AGE_ONE_YEAR, derby, express, gzip, path, publicPath, root, server, sink, staticPages, store;

path = require('path');

express = require('express');

derby = require('derby');

gzip = require('connect-gzip');

sink = require('./sink');

MAX_AGE_ONE_YEAR = {
  maxAge: 1000 * 60 * 60 * 24 * 365
};

root = __dirname;

publicPath = path.join(root, 'public');

staticPages = derby.createStatic(root);

(server = express.createServer()).use(gzip.staticGzip(publicPath, MAX_AGE_ONE_YEAR)).use(express.favicon()).use(express.bodyParser()).use(express.methodOverride()).use(gzip.gzip()).use(sink.router()).use(server.router);

server.configure('development', function() {
  return server.error(function(err, req, res, next) {
    if (err) console.log(err.stack ? err.stack : err);
    return next(err);
  });
});

server.error(function(err, req, res) {
  var message, status;
  message = err.message || err.toString();
  status = parseInt(message);
  return res.send((400 <= status && status < 600) ? status : 500);
});

server.all('*', function(req) {
  throw "404: " + req.url;
});

store = sink.createStore({
  redis: {
    db: 1
  },
  listen: server
});

store.flush();

server.listen(3001);

console.log('Express server started in %s mode', server.settings.env);

console.log('Go to: http://localhost:%d/', server.address().port);
