var EventDispatcher;

EventDispatcher = module.exports = function(options) {
  if (options == null) options = {};
  this._onTrigger = options.onTrigger || function() {};
  this._onBind = options.onBind || function(name) {
    return name;
  };
  this.clear();
};

EventDispatcher.prototype = {
  clear: function() {
    return this._names = {};
  },
  bind: function(name, listener) {
    var names, obj;
    name = this._onBind(name, listener);
    names = this._names;
    obj = names[name] || {};
    obj[JSON.stringify(listener)] = listener;
    return names[name] = obj;
  },
  trigger: function(name, value, arg0, arg1, arg2) {
    var count, key, listener, listeners, names, onTrigger;
    names = this._names;
    listeners = names[name];
    onTrigger = this._onTrigger;
    count = 0;
    for (key in listeners) {
      listener = listeners[key];
      count++;
      if (onTrigger(name, listener, value, arg0, arg1, arg2) !== false) continue;
      delete listeners[key];
      count--;
    }
    if (!count) return delete names[name];
  }
};
