var ANSI_CODES, APP_COFFEE, APP_HTML, APP_JS, APP_STYL, BASE_STYL, GITIGNORE_COFFEE, GITIGNORE_JS, MAKEFILE_COFFEE, README, RESET_STYL, SERVER, SERVER_COFFEE, SERVER_JS, abort, createProject, derby, emptyDirectory, exec, fs, join, makeCallback, mkdir, mkdirp, newProject, packageJson, printUsage, program, render, style, styleTag, writeFile, _404_HTML, _404_STYL;

derby = require('../derby');

exec = require('child_process').exec;

program = require('commander');

mkdirp = require('mkdirp');

fs = require('fs');

join = require('path').join;

APP_COFFEE = '{get, view, ready} = require(\'derby\').createApp module\n\n## ROUTES ##\n\nstart = +new Date()\n\n# Derby routes can be rendered on the client and the server\nget \'/:room?\', (page, model, {room}) ->\n  room ||= \'home\'\n\n  # Subscribes the model to any updates on this room\'s object. Also sets a\n  # model reference to the room. This is equivalent to:\n  #   model.set \'_room\', model.ref "rooms.#{room}"\n  model.subscribe _room: "rooms.#{room}", ->\n\n    # setNull will set a value if the object is currently null or undefined\n    model.setNull \'_room.welcome\', "Welcome to #{room}!"\n\n    model.incr \'_room.visits\'\n\n    # This value is set for when the page initially renders\n    model.set \'_timer\', \'0.0\'\n    # Reset the counter when visiting a new route client-side\n    start = +new Date()\n\n    # Render will use the model data as well as an optional context object\n    page.render\n      room: room\n      randomUrl: parseInt(Math.random() * 1e9).toString(36)\n\n\n## CONTROLLER FUNCTIONS ##\n\nready (model) ->\n  timer = null\n\n  # Exported functions are exposed as a global in the browser with the same\n  # name as the module that includes Derby. They can also be bound to DOM\n  # events using the "x-bind" attribute in a template.\n  exports.stop = ->\n\n    # Any path name that starts with an underscore is private to the current\n    # client. Nothing set under a private path is synced back to the server.\n    model.set \'_stopped\', true\n    clearInterval timer\n\n  do exports.start = ->\n    model.set \'_stopped\', false\n    timer = setInterval ->\n      model.set \'_timer\', (((+new Date()) - start) / 1000).toFixed(1)\n    , 100\n';

APP_JS = 'var <<app>> = require(\'derby\').createApp(module),\n    get = <<app>>.get,\n    view = <<app>>.view,\n    ready = <<app>>.ready,\n    start;\n\n// ROUTES //\n\nstart = +new Date();\n\n// Derby routes can be rendered on the client and the server\nget(\'/:room?\', function(page, model, params) {\n  var room = params.room || \'home\';\n\n  // Subscribes the model to any updates on this room\'s object. Also sets a\n  // model reference to the room. This is equivalent to:\n  //   model.set(\'_room\', model.ref(\'rooms.\' + room));\n  model.subscribe({ _room: \'rooms.\' + room }, function() {\n\n    // setNull will set a value if the object is currently null or undefined\n    model.setNull(\'_room.welcome\', \'Welcome to \' + room + \'!\');\n\n    model.incr(\'_room.visits\');\n\n    // This value is set for when the page initially renders\n    model.set(\'_timer\', \'0.0\');\n    // Reset the counter when visiting a new route client-side\n    start = +new Date();\n\n    // Render will use the model data as well as an optional context object\n    page.render({\n      room: room,\n      randomUrl: parseInt(Math.random() * 1e9).toString(36)\n    });\n  });\n});\n\n\n// CONTROLLER FUNCTIONS //\n\nready(function(model) {\n  var timer;\n\n  // Exported functions are exposed as a global in the browser with the same\n  // name as the module that includes Derby. They can also be bound to DOM\n  // events using the "x-bind" attribute in a template.\n  exports.stop = function() {\n\n    // Any path name that starts with an underscore is private to the current\n    // client. Nothing set under a private path is synced back to the server.\n    model.set(\'_stopped\', true);\n    clearInterval(timer);\n  };\n\n  (exports.start = function() {\n    model.set(\'_stopped\', false);\n    timer = setInterval(function() {\n      model.set(\'_timer\', (((+new Date()) - start) / 1000).toFixed(1));\n    }, 100);\n  })();\n});\n';

SERVER_COFFEE = 'path = require \'path\'\nexpress = require \'express\'\nderby = require \'derby\'\ngzip = require \'connect-gzip\'\n<<app>> = require \'../<<app>>\'\n\n\n## SERVER CONFIGURATION ##\n\nMAX_AGE_ONE_YEAR = maxAge: 1000 * 60 * 60 * 24 * 365\nroot = path.dirname path.dirname __dirname\npublicPath = path.join root, \'public\'\nstaticPages = derby.createStatic root\n\n(server = express.createServer())\n  # The express.static middleware can be used instead of gzip.staticGzip\n  .use(gzip.staticGzip publicPath, MAX_AGE_ONE_YEAR)\n  .use(express.favicon())\n\n  # Uncomment to add form data parsing support\n  # .use(express.bodyParser())\n  # .use(express.methodOverride())\n\n  # Uncomment and supply secret to add Derby session handling\n  # Derby session middleware creates req.model and subscribes to _session\n  # .use(express.cookieParser())\n  # .use(express.session(secret: \'\', cookie: MAX_AGE_ONE_YEAR))\n  # .use(<<app>>.session())\n\n  # Remove to disable dynamic gzipping\n  .use(gzip.gzip())\n\n  # The router method creates an express middleware from the app\'s routes\n  .use(<<app>>.router())\n  .use(server.router)\n\n\n## ERROR HANDLING ##\n\nserver.configure \'development\', ->\n  # Log errors in development only\n  server.error (err, req, res, next) ->\n    if err then console.log(if err.stack then err.stack else err)\n    next err\n\nserver.error (err, req, res) ->\n  ## Customize error handling here ##\n  message = err.message || err.toString()\n  status = parseInt message\n  if status is 404 then staticPages.render \'404\', res, {url: req.url}, 404\n  else res.send if 400 <= status < 600 then status else 500\n\n\n## SERVER ONLY ROUTES ##\n\nserver.all \'*\', (req) ->\n  throw "404: #{req.url}"\n\n\n## STORE SETUP ##\n\nstore = <<app>>.createStore listen: server\n\n## TODO: Remove when using a database ##\n# Clear all data every time the node server is started\nstore.flush()\n\nserver.listen 3000\nconsole.log \'Express server started in %s mode\', server.settings.env\nconsole.log \'Go to: http://localhost:%d/\', server.address().port\n';

SERVER_JS = 'var path = require(\'path\'),\n    express = require(\'express\'),\n    derby = require(\'derby\'),\n    gzip = require(\'connect-gzip\'),\n    <<app>> = require(\'../<<app>>\');\n\n\n// SERVER CONFIGURATION //\n\nvar MAX_AGE_ONE_YEAR = { maxAge: 1000 * 60 * 60 * 24 * 365 },\n    root = path.dirname(path.dirname(__dirname)),\n    publicPath = path.join(root, \'public\'),\n    staticPages = derby.createStatic(root),\n    server, store;\n\n(server = express.createServer())\n  // The express.static middleware can be used instead of gzip.staticGzip\n  .use(gzip.staticGzip(publicPath, MAX_AGE_ONE_YEAR))\n  .use(express.favicon())\n\n  // Uncomment to add form data parsing support\n  // .use(express.bodyParser())\n  // .use(express.methodOverride())\n\n  // Uncomment and supply secret to add Derby session handling\n  // Derby session middleware creates req.model and subscribes to _session\n  // .use(express.cookieParser())\n  // .use(express.session({ secret: \'\', cookie: MAX_AGE_ONE_YEAR }))\n  // .use(<<app>>.session())\n\n  // Remove to disable dynamic gzipping\n  .use(gzip.gzip())\n\n  // The router method creates an express middleware from the app\'s routes\n  .use(<<app>>.router())\n  .use(server.router);\n\n\n// ERROR HANDLING //\n\nserver.configure(\'development\', function() {\n  // Log errors in development only\n  server.error(function(err, req, res, next) {\n    if (err) console.log(err.stack ? err.stack : err);\n    next(err);\n  });\n});\n\nserver.error(function(err, req, res) {\n  // Customize error handling here //\n  var message = err.message || err.toString(),\n      status = parseInt(message);\n  if (status === 404) {\n    staticPages.render(\'404\', res, {url: req.url}, 404);\n  } else {\n    res.send( ((status >= 400) && (status < 600)) ? status : 500 );\n  }\n});\n\n\n// SERVER ONLY ROUTES //\n\nserver.all(\'*\', function(req) {\n  throw \'404: \' + req.url;\n});\n\n\n// STORE SETUP //\n\nstore = <<app>>.createStore({ listen: server });\n\n// TODO: Remove when using a database //\n// Clear all data every time the node server is started\nstore.flush();\n\nserver.listen(3000);\nconsole.log(\'Express server started in %s mode\', server.settings.env);\nconsole.log(\'Go to: http://localhost:%d/\', server.address().port);\n';

APP_HTML = '<!--\n  Derby templates are similar to Mustache, except that they are first\n  parsed as HTML, and there are a few extensions to make them work directly\n  with models. A single HTML template defines the HTML output, the event\n  handlers that update the model after user interaction, and the event handlers\n  that update the DOM when the model changes.\n\n  As in Mustache, double and triple curly braces output a value literally.\n  Derby templates add double and triple parentheses, which output a value\n  and set up model <- -> view bindings for that object.\n\n  Elements that end in colon define template names. Pre-defined templates\n  are capitalized by convention, but template names are case-insensitive.\n  Pre-defined templates are automatically included when the page is rendered.\n-->\n\n<Title:>\n  {{room}} - ((_room.visits)) visits\n\n<Body:>\n  <h1>((_room.welcome))</h1>\n  <p><label>Welcome message: <input value="((_room.welcome))"></label>\n\n  <p>This page has been visted ((_room.visits)) times. {{> timer}}\n\n  <p>Let\'s go <a href="/{{randomUrl}}">somewhere random</a>.\n\n<timer:>\n  ((#_stopped))\n    <a x-bind="click:start">Start timer</a>\n  ((^))\n    You have been here for ((_timer)) seconds. <a x-bind="click:stop">Stop</a>\n  ((/))\n';

_404_HTML = '<!--\n  This is a static template file, so it doesn\'t have an associated app.\n  It is rendered by the server via a staticPages renderer.\n\n  Since static pages don\'t include the Derby client library, they can\'t have\n  bound variables that automatically update. However, they do support initial\n  template tag rendering from a context object and/or model.\n-->\n\n<Title:>\n  Not found\n\n<Body:>\n  <h1>404</h1>\n  <p>Sorry, we can\'t find anything at <b>{{url}}</b>.\n  <p>Try heading back to the <a href="/">home page</a>.\n';

RESET_STYL = 'body,h1,h2,h3,h4,th {\n  font: 13px/normal Arial,sans-serif;\n}\nbody {\n  background: #fff;\n  color: #000;\n}\nbody,fieldset,form,h1,h2,h3,h4,li,ol,p,td,th,ul {\n  margin: 0;\n  padding: 0;\n}\nul {\n  margin: 0 normal;\n}\ntable {\n  border-collapse: collapse;\n  border-spacing: 0;\n}\nfieldset,img {\n  border: 0;\n}\n';

BASE_STYL = '@import "./reset";\n@import "nib/vendor";\n\nbody {\n  padding: 2em;\n}\nh1 {\n  font-size: 2em;\n  margin-bottom: .5em;\n}\np {\n  line-height: 2em;\n}\n';

APP_STYL = '@import "../base";\n';

_404_STYL = '@import "./base";\n';

SERVER = 'require(\'./lib/server\');\n';

MAKEFILE_COFFEE = 'compile:\n	./node_modules/coffee-script/bin/coffee -bw -o ./lib -c ./src\n';

README = '# <<project>>\n';

GITIGNORE_COFFEE = '.DS_Store\nnode_modules\npublic/gen\nlib/\n';

GITIGNORE_JS = '.DS_Store\nnode_modules\npublic/gen\n';

packageJson = function(project, useCoffee) {
  var package;
  package = {
    name: project,
    description: '',
    version: '0.0.0',
    main: './server.js',
    dependencies: {
      derby: '*',
      express: '>=2 <3',
      'connect-gzip': '>=0.1.5'
    },
    private: true
  };
  if (useCoffee) {
    package.devDependencies = {
      'coffee-script': '>=1.1.2'
    };
  }
  return JSON.stringify(package, null, '  ');
};

printUsage = true;

ANSI_CODES = {
  'off': 0,
  'bold': 1,
  'italic': 3,
  'underline': 4,
  'blink': 5,
  'inverse': 7,
  'hidden': 8,
  'black': 30,
  'red': 31,
  'green': 32,
  'yellow': 33,
  'blue': 34,
  'magenta': 35,
  'cyan': 36,
  'white': 37,
  'black_bg': 40,
  'red_bg': 41,
  'green_bg': 42,
  'yellow_bg': 43,
  'blue_bg': 44,
  'magenta_bg': 45,
  'cyan_bg': 46,
  'white_bg': 47
};

styleTag = function(name) {
  return "\033[" + ANSI_CODES[name] + "m";
};

style = function(styles, text) {
  var out, style, _i, _len;
  styles = styles.split(' ');
  out = '';
  for (_i = 0, _len = styles.length; _i < _len; _i++) {
    style = styles[_i];
    out += styleTag(style);
  }
  return out + text + styleTag('off');
};

emptyDirectory = function(path, callback) {
  return fs.readdir(path, function(err, files) {
    if (err && err.code !== 'ENOENT') throw err;
    return callback(!files || !files.length);
  });
};

makeCallback = function(path, callback) {
  return function(err) {
    if (err) throw err;
    console.log(style('green', '  created: ') + path);
    if (callback) return callback();
  };
};

mkdir = function(path, callback) {
  return mkdirp(path, 0755, makeCallback(path, callback));
};

writeFile = function(path, text, callback) {
  return fs.writeFile(path, text, makeCallback(path, callback));
};

render = function(template, ctx) {
  var key, re, value;
  for (key in ctx) {
    value = ctx[key];
    re = new RegExp('<<' + key + '>>', 'g');
    template = template.replace(re, value);
  }
  return template;
};

abort = function(message) {
  message || (message = style('red bold', '\n  Aborted  \n'));
  console.error(message);
  return process.exit(1);
};

createProject = function(dir, app, useCoffee) {
  var appScripts, appStyles, appViews, count, dirPath, finish, logComplete, project, scripts, serverScripts, styles, views, wait;
  dirPath = join(process.cwd(), dir);
  project = dir === '.' ? 'derby-app' : dir;
  views = dir + '/views';
  styles = dir + '/styles';
  scripts = useCoffee ? dir + '/src' : dir + '/lib';
  appViews = join(views, app);
  appStyles = join(styles, app);
  appScripts = join(scripts, app);
  serverScripts = scripts + '/server';
  logComplete = function() {
    var message;
    message = style('green bold', '\n  Project created!') + '\n\n  Try it out:';
    if (dir !== '.') message += "\n    $ cd " + dir;
    if (program.noinstall) message += '\n    $ npm install';
    if (useCoffee) {
      message += "\n    $ make\n\n  Then in a new terminal:\n    $ cd " + dirPath;
    }
    message += "\n    $ node server.js\n\n  More info at: http://derbyjs.com/\n";
    return console.log(message);
  };
  finish = function() {
    if (program.noinstall) return logComplete();
    process.chdir(dir);
    console.log('\n  Installing dependencies. This may take a little while...');
    return exec('npm install', function(err, stdout, stderr) {
      if (err) return console.error(stderr);
      if (stdout) console.log(stdout.replace(/^|\n/g, '\n  '));
      return logComplete();
    });
  };
  count = 0;
  wait = function(callback) {
    count++;
    return function() {
      if (callback) callback();
      if (!--count) return finish();
    };
  };
  return mkdir(dir, function() {
    mkdir(dir + '/public/img', wait());
    mkdir(appViews, wait(function() {
      writeFile(appViews + '/index.html', APP_HTML, wait());
      return writeFile(views + '/404.html', _404_HTML, wait());
    }));
    mkdir(appStyles, wait(function() {
      writeFile(appStyles + '/index.styl', APP_STYL, wait());
      writeFile(styles + '/404.styl', _404_STYL, wait());
      writeFile(styles + '/reset.styl', RESET_STYL, wait());
      return writeFile(styles + '/base.styl', BASE_STYL, wait());
    }));
    if (useCoffee) {
      mkdir(appScripts, wait(function() {
        return writeFile(appScripts + '/index.coffee', render(APP_COFFEE, {
          app: app
        }), wait());
      }));
      mkdir(serverScripts, wait(function() {
        return writeFile(serverScripts + '/index.coffee', render(SERVER_COFFEE, {
          app: app
        }), wait());
      }));
      writeFile(dir + '/Makefile', MAKEFILE_COFFEE, wait());
      writeFile(dir + '/.gitignore', GITIGNORE_COFFEE, wait());
    } else {
      mkdir(appScripts, wait(function() {
        return writeFile(appScripts + '/index.js', render(APP_JS, {
          app: app
        }), wait());
      }));
      mkdir(serverScripts, wait(function() {
        return writeFile(serverScripts + '/index.js', render(SERVER_JS, {
          app: app
        }), wait());
      }));
      writeFile(dir + '/.gitignore', GITIGNORE_JS, wait());
    }
    writeFile(dir + '/server.js', SERVER, wait());
    writeFile(dir + '/package.json', packageJson(project, useCoffee), wait());
    return writeFile(dir + '/README.md', render(README, {
      project: project
    }), wait());
  });
};

newProject = function(dir, app) {
  var directory, type, useCoffee;
  if (dir == null) dir = '.';
  if (app == null) app = 'app';
  printUsage = false;
  useCoffee = program.coffee;
  type = useCoffee ? 'CoffeeScript ' : '';
  directory = style('bold', dir === '.' ? 'the current directory' : dir);
  console.log(("\n  Creating " + type + "project in " + directory + " with the application ") + style('bold', app) + '\n');
  return emptyDirectory(dir, function(empty) {
    if (!empty) {
      return program.confirm('  Destination is not empty. Continue? ', function(ok) {
        if (!ok) abort();
        process.stdin.destroy();
        return createProject(dir, app, useCoffee);
      });
    }
    return createProject(dir, app, useCoffee);
  });
};

program.version(derby.version).option('-c, --coffee', 'create files using CoffeeScript').option('-n, --noinstall', "don't run `npm install`");

program.command('new [dir] [app]').description('\nCreate a new Derby project. If no directory name is specified, or the\nname `.` is used, the project will be created in the current directory.\nA name for the default app may be specified optionally.').action(newProject);

program.parse(process.argv);

if (printUsage) console.log('\n  See `derby --help` for usage\n');
